// #autoload
// #name = Yogi MatchStats
// #version = 3.0
// #date = July 26, 2002
// #author = Andrew Weiland
// #warrior = Yogi
// #email = yogi@tribalwar.com
// #description = Capture match stats from Demos.
// #category = Yogi's Scripts
// #status = beta
// #acknowledgements = Grinder, Debig3, Writer, Halide, Shoddy, Diogenes
// #include = support/player_support.cs
// #include = support/team_tracker.cs
// #include = support/file_tools.cs
// #include = support/callback.cs
// #include = support/mission_callbacks.cs
// #readme = scripts/autoexec/yogi/readme/yogimatchstats.txt
// #config = YMSOptions


exec("scripts/damageTypes.cs");

$YogiWriteOut=false;
$YogiDemoPlayer="";
package YogiMatchStats {

// -----------------------------------------------------------------------------

function playDemo(%file) {
         echo("++++++++++++++++++++++++++++++++++++++++++++++++++");
         echo("++++++++++++++++++++++++++++++++++++++++++++++++++");
         echo("++++++++++++++++++++++++++++++++++++++++++++++++++");
         GlobalActionMap.bindCmd(keyboard, "F5", "", "YogiStatsDialog();");
         $YogiWriteOut=false;
         $YogiDemoPlayer="";
         YogiAddCallBacks();
         return parent::playDemo(%file);
}

// -----------------------------------------------------------------------------

function YogiStatsDialog() {
         $globalActionMapOnly=false;
         GlobalActionMap.unbind(keyboard, space);
         canvas.pushDialog(YogiStatsOptions);
}

// -----------------------------------------------------------------------------

function YogiStatsDialogClose() {
         GlobalActionMap.bindCmd(keyboard, "space", "", "toggleDemoPause();");
         $globalActionMapOnly=true;
         canvas.popDialog(YogiStatsOptions);
}

// -----------------------------------------------------------------------------

function YogiStartTracking() {
         GlobalActionMap.bindCmd(keyboard, "space", "", "toggleDemoPause();");
         $globalActionMapOnly=true;
         $YogiWriteOut=true;
         canvas.popDialog(YogiStatsOptions);
         YogiCleanUpStats();
}

// -----------------------------------------------------------------------------

function demoPlaybackComplete() {
         // Dump the data
         YogiWriteHTML();
       //  if ($YogiPref::MatchStats::WriteOut) YogiWriteHTML();
         YogiCleanUpStats();
            GlobalActionMap.unbind(keyboard, F5);
       YogiRemoveCallbacks();
       //  $YogiPlayDemo=false;
       $YogiWriteOut=false;
         parent::demoPlaybackComplete();
}

// -----------------------------------------------------------------------------

function YogiWriteHTML() {
        if (!$YogiWriteOut) return;
        if ($YogiPlayerNum==0) return;
        %map = $YogiStatsmap;
        %reason = $YogiPref::MatchStats::Reason;
        %otag = $YogiPref::MatchStats::OTag;
        %date = $YogiPref::MatchStats::Date;
        %tag = $YogiPref::MatchStats::PlayerTag;
        YogiUpdateTeamPoints(1);
        YogiUpdateTeamPoints(2);
        // What team was I on now?
        %index = YogiGetPlayerIndex($YogiDemoPlayer);
        %fteam = $YogiPlayerList[%index].team;
        %fteam = (%fteam==1) ? 1 : 2;
        %oteam = (%fteam==1) ? 2 : 1;
        
        // Team Scores
        %fscore = $YogiTeamScores[%fteam];
        %oscore = $YogiTeamScores[%oteam];
        %fpoints = $YogiTeamPoints[%fteam];
        %opoints = $YogiTeamPoints[%oteam];

        // Team Names
        %team1= $YogiStatsteam1;
        %team2= $YogiStatsteam2;
        
        // Time Played
        %length = $YogiTimeLimit - $YogiTimePlayed;
        %mins = mFloor(%length);
        %secs = (%length - %mins) * 60;
        %secs = getSubStr(%secs, 0, 2);
        if (%secs<10) %secs="0" @ %secs;
        %length = %mins @ ":" @ %secs;


        YogiSortByTeam();
        YogiSortNames();


         %searchnum=1;
         %filename = "matchstats/" @ %map @ %searchnum @ ".html";
         while (isFile(%filename)) {
                  %searchnum++;
                  %filename = "matchstats/" @ %map @ %searchnum @ ".html";
         }


         %outfile = new FileObject();
         %outfile.openForWrite(%filename);
         %headerfile = new FileObject();
         %headerfile.openForRead("matchstats/templates/header.tmpl");
         %header = %headerfile.getContents("matchstats/templates/header.tmpl");
         %headerfile.close();
         %headerfile.delete();
         %header = strreplace(%header, "%cssfile", $YogiPref::MatchStats::Css);
         %outfile.write(%filename, %header);


         %toptable = new FileObject();
         %toptable.openForRead("matchstats/templates/toptable.tmpl");
         %top = %toptable.getContents("matchstats/templates/toptable.tmpl");
         %toptable.close();
         %toptable.delete();
         
         %top = strreplace(%top, "%date", %date);
         %top = strreplace(%top, "%ladder", %reason);
         %top = strreplace(%top, "%opponent", %otag);
         %top = strreplace(%top, "%map", %map);
         %top = strreplace(%top, "%ftag", %tag);
         %top = strreplace(%top, "%otag", %otag);
         %top = strreplace(%top, "%fscore", %fscore);
         %top = strreplace(%top, "%oscore", %oscore);
         %top = strreplace(%top, "%fpoints", %fpoints);
         %top = strreplace(%top, "%opoints", %opoints);
         %top = strreplace(%top, "%length", %length);


         %outfile.append(%filename, %top);
         
         %theader = new FileObject();
         %theader.openForRead("matchstats/templates/flagheader.tmpl");
         %head = %theader.getContents("matchstats/templates/flagheader.tmpl");
         %theader.close();
         %theader.delete();

         %tfooter = new FileObject();
         %tfooter.openForRead("matchstats/templates/flagfooter.tmpl");
         %footer = %tfooter.getContents("matchstats/templates/flagfooter.tmpl");
         %tfooter.close();
         %tfooter.delete();


         %fbodyfile = new FileObject();
         %fbodyfile.openForRead("matchstats/templates/flagbody.tmpl");
         %fbody = %fbodyfile.getContents("matchstats/templates/flagbody.tmpl");
         %fbodyfile.close();
         %fbodyfile.delete();

         %classes[0]="light";
         %classes[1]="dark";
         %cls=0;

         //----- Team Tables -----
         %outfile.append(%filename, %head);
         for (%y=1; %y<=2; %y++) {
             if (%y==1) %cteam = %fteam;
             else %cteam = %oteam;

             //if (%y==1) {
             //   %theader2 = strreplace(%theader, "%team", %team1);
             //}
             //else {
             //     %theader2 = strreplace(%theader, "%team", %team2);
             //}

             %grabs=0;
             %caps=0;
             %returns=0;
             %assists=0;
             %drops=0;
             %standoffreturns=0;
             %pickups=0;

             for (%x=0; %x < $YogiPlayerNum; %x++) {
                 %class= %classes[%cls];
                 %cls = (%cls==0) ? 1 : 0;

                 %guy = $YogiPlayerList[%x];
                 if (%guy.team !$= $PLAYER_ERROR && %guy.team == %y) {
                    %work = %fbody;
                    %work = strreplace(%work, "%class", %class);
                    %name = StripMLControlChars(%guy.name);
                    %work = strreplace(%work, "%name", %name);
                    %work = strreplace(%work, "%grabs", %guy.grabs);
                    %work = strreplace(%work, "%caps", %guy.caps);
                    %work = strreplace(%work, "%returns", %guy.returns);
                    %work = strreplace(%work, "%assists", %guy.assists);
                    %work = strreplace(%work, "%pickups", %guy.pickups);
                    %work = strreplace(%work, "%standoffs", %guy.standoffreturns);
                    %work = strreplace(%work, "%drops", %guy.drops);
                    //%tbody = %tbody @ %work;
                    %outfile.append(%filename, %work);
                    %grabs+=%guy.grabs;
                    %caps+=%guy.caps;
                    %returns+=%guy.returns;
                    %assists+=%guy.assists;
                    %pickups+= %guy.pickups;
                    %drops+=%guy.drops;
                    %standoffreturns+=%guy.standoffreturns;
                 }
             }
             %work = %fbody;
             %class="totals";
             %name = "Total";
             
             %work = strreplace(%work, "%class", %class);
             %work = strreplace(%work, "%name", %name);
             %work = strreplace(%work, "%grabs", %grabs);
             %work = strreplace(%work, "%caps", %caps);
             %work = strreplace(%work, "%returns", %returns);
             %work = strreplace(%work, "%assists", %assists);
             %work = strreplace(%work, "%pickups", %pickups);
             %work = strreplace(%work, "%standoffs", %standoffreturns);
             %work = strreplace(%work, "%drops", %drops);
             %outfile.append(%filename, %work);
             
//             %tscore = $YogiTeamScores[%y];
    //         %theader2 = strreplace(%theader2, "%tscore", %tscore);

             // Header
  //           %outfile.append(%filename, %theader2);
             // Table body
//             %outfile.append(%filename, %tbody);
             // Totals
//             %outfile.append(%filename, %work);
             // Table footer

         }
         %outfile.append(%filename, %footer);
         
         
         // Kills and Deaths Stats
         %headerfile = new FileObject();
         %headerfile.openForRead("matchstats/templates/killsheader.tmpl");
         %header = %headerfile.getContents("matchstats/templates/killsheader.tmpl");
         %headerfile.close();
         %headerfile.delete();

         %footerfile = new FileObject();
         %footerfile.openForRead("matchstats/templates/killsfooter.tmpl");
         %footer = %footerfile.getContents("matchstats/templates/killsfooter.tmpl");
         %footerfile.close();
         %footerfile.delete();
         
         %bodyfile = new FileObject();
         %bodyfile.openForRead("matchstats/templates/killsbody.tmpl");
         %fbody = %bodyfile.getContents("matchstats/templates/killsbody.tmpl");
         %bodyfile.close();
         %bodyfile.delete();

         %outfile.append(%filename, %header);
         %classes[0]="smalllight";
         %classes[1]="smalldark";
         %cls=0;
         
         for (%y=1; %y<=2; %y++) {
             if (%y==1) %cteam = %fteam;
             else %cteam = %oteam;

             %score=0;
             %kills=0;
             %deaths=0;
             %cgkills=0;
             %cgdeaths=0;
             %plaskills=0;
             %plasdeaths=0;
             %disckills=0;
             %discdeaths=0;
             %lancekills=0;
             %lancedeaths=0;
             %rocketkills=0;
             %rocketdeaths=0;
             %laserkills=0;
             %laserdeaths=0;
             %mortarkills=0;
             %mortardeaths=0;
             %grenadekills=0;
             %grenadedeaths=0;
             %turretkills=0;
             %turretdeaths=0;
             %vehiclekills=0;
             %vehicledeaths=0;
             %suicides=0;
             %tks=0;
             %carriertks=0;
             %carrierkills=0;
             %points=0;

             for (%x=0; %x < $YogiPlayerNum; %x++) {
                 %class= %classes[%cls];
                 %cls = (%cls==0) ? 1 : 0;

                 %guy = $YogiPlayerList[%x];
                 if (%guy.team !$= $PLAYER_ERROR && %guy.team == %y) {
                    %work = %fbody;
                    %work = strreplace(%work, "%class", %class);
                    %name = StripMLControlChars(%guy.name);
                    %work = strreplace(%work, "%name", %name);
                    %work = strreplace(%work, "%score", %guy.points);
                    %work = strreplace(%work, "%kills", %guy.kills);
                    %work = strreplace(%work, "%deaths", %guy.deaths);
                    %work = strreplace(%work, "%cgkills", %guy.cgkills);
                    %work = strreplace(%work, "%cgdeaths", %guy.cgdeaths);
                    %work = strreplace(%work, "%plaskills", %guy.plaskills);
                    %work = strreplace(%work, "%plasdeaths", %guy.plasdeaths);
                    %work = strreplace(%work, "%disckills", %guy.disckills);
                    %work = strreplace(%work, "%discdeaths", %guy.discdeaths);
                    %work = strreplace(%work, "%lancekills", %guy.lancekills);
                    %work = strreplace(%work, "%lancedeaths", %guy.lancedeaths);
                    %work = strreplace(%work, "%rocketkills", %guy.rocketkills);
                    %work = strreplace(%work, "%rocketdeaths", %guy.rocketdeaths);
                    %work = strreplace(%work, "%laserkills", %guy.laserkills);
                    %work = strreplace(%work, "%laserdeaths", %guy.laserdeaths);
                    %work = strreplace(%work, "%mortarkills", %guy.mortarkills);
                    %work = strreplace(%work, "%mortardeaths", %guy.mortardeaths);
                    %work = strreplace(%work, "%grenadekills", %guy.grenadekills);
                    %work = strreplace(%work, "%grenadedeaths", %guy.grenadedeaths);
                    %work = strreplace(%work, "%turretkills", %guy.turretkills);
                    %work = strreplace(%work, "%turretdeaths", %guy.turretdeaths);
                    %work = strreplace(%work, "%vehiclekills", %guy.vehiclekills);
                    %work = strreplace(%work, "%vehicledeaths", %guy.vehicledeaths);
                    %work = strreplace(%work, "%suicides", %guy.suicides);
                    %work = strreplace(%work, "%tks", %guy.tks);
                    %work = strreplace(%work, "%carriertks", %guy.carriertks);
                    %work = strreplace(%work, "%carrierkills", %guy.carrierkills);
                    //%tbody = %tbody @ %work;
                    %outfile.append(%filename, %work);
                    
                    %score+=%guy.score;
                    %kills+=%guy.kills;
                    %deaths+=%guy.deaths;
                    %cgkills+=%guy.cgkills;
                    %cgdeaths+=%guy.cgdeaths;
                    %plaskills+=%guy.plaskills;
                    %plasdeaths+=%guy.plasdeaths;
                    %disckills+=%guy.disckills;
                    %discdeaths+=%guy.discdeaths;
                    %lancekills+=%guy.lancekills;
                    %lancedeaths+=%guy.lancedeaths;
                    %rocketkills+=%guy.rocketkills;
                    %rocketdeaths+=%guy.rocketdeaths;
                    %laserkills+=%guy.laserkills;
                    %laserdeaths+=%guy.laserdeaths;
                    %mortarkills+=%guy.mortarkills;
                    %mortardeaths+=%guy.mortardeaths;
                    %grenadekills+=%guy.grenadekills;
                    %grenadedeaths+=%guy.grenadedeaths;
                    %turretkills+=%guy.turretkills;
                    %turretdeaths+=%guy.turretdeaths;
                    %vehiclekills+=%guy.vehiclekills;
                    %vehicledeaths+=%guy.vehicledeaths;
                    %suicides+=%guy.suicides;
                    %tks+=%guy.tks;
                    %carriertks+=%guy.carriertks;
                    %carrierkills+=%guy.carrierkills;
                    %points+=%guy.points;
                    
                 }
             }
             %work = %fbody;
             %class="smalltotals";
             %name = "Total";

             %work = strreplace(%work, "%class", %class);
             %work = strreplace(%work, "%name", %name);

             //%work = strreplace(%work, "%score", %score);
             %work = strreplace(%work, "%kills", %kills);
             %work = strreplace(%work, "%deaths", %deaths);
             %work = strreplace(%work, "%cgkills", %cgkills);
             %work = strreplace(%work, "%cgdeaths", %cgdeaths);
             %work = strreplace(%work, "%plaskills", %plaskills);
             %work = strreplace(%work, "%plasdeaths", %plasdeaths);
             %work = strreplace(%work, "%disckills", %disckills);
             %work = strreplace(%work, "%discdeaths", %discdeaths);
             %work = strreplace(%work, "%lancekills", %lancekills);
             %work = strreplace(%work, "%lancedeaths", %lancedeaths);
             %work = strreplace(%work, "%rocketkills", %rocketkills);
             %work = strreplace(%work, "%rocketdeaths", %rocketdeaths);
             %work = strreplace(%work, "%laserkills", %laserkills);
             %work = strreplace(%work, "%laserdeaths", %laserdeaths);
             %work = strreplace(%work, "%mortarkills", %mortarkills);
             %work = strreplace(%work, "%mortardeaths", %mortardeaths);
             %work = strreplace(%work, "%grenadekills", %grenadekills);
             %work = strreplace(%work, "%grenadedeaths", %grenadedeaths);
             %work = strreplace(%work, "%turretkills", %turretkills);
             %work = strreplace(%work, "%turretdeaths", %turretdeaths);
             %work = strreplace(%work, "%vehiclekills", %vehiclekills);
             %work = strreplace(%work, "%vehicledeaths", %vehicledeaths);
             %work = strreplace(%work, "%suicides", %suicides);
             %work = strreplace(%work, "%tks", %tks);
             %work = strreplace(%work, "%carriertks", %carriertks);
             %work = strreplace(%work, "%carrierkills", %carrierkills);
             %work = strreplace(%work, "%score", %points);

             %outfile.append(%filename, %work);

         }

         %outfile.append(%filename, %footer);

         
         
         
         %footerfile = new FileObject();
         %footerfile.openForRead("matchstats/templates/footer.tmpl");
         %outfile.append(%filename, %footerfile.getContents("matchstats/templates/footer.tmpl"));
         
         %footerfile.close();
         %footerfile.delete();
         
         %outfile.close();
         %outfile.delete();

}

// -----------------------------------------------------------------------------

// A really bad sorting algorithm
function YogiSortByTeam() {
        for (%i = 0; %i < $YogiPlayerNum; %i++) {
            %min = %i;

            for (%j = %i + 1; %j < $YogiPlayerNum; %j++) {

                if ($YogiPlayerList[%j].team < $YogiPlayerList[%min].team) {
                    %min = %j;
                }

            }
            %temp = $YogiPlayerList[%min];
            $YogiPlayerList[%min] = $YogiPlayerList[%i];
	        $YogiPlayerList[%i] = %temp;
        }
}

// -----------------------------------------------------------------------------

function YogiSortNames() {
         for (%d=1; %d <= 2; %d++) {
             for (%i = 0; %i < $YogiPlayerNum; %i++) {
                 %min = %i;

                 for (%j = %i + 1; %j < $YogiPlayerNum; %j++) {
                     if ($YogiPlayerList[%j].team==%d && $YogiPlayerList[%min].team == %d) {
                        if (stricmp($YogiPlayerList[%j].name, $YogiPlayerList[%min].name) == -1) {
                           %min = %j;
                        }
                     }
                 }
                 %temp = $YogiPlayerList[%min];
                 $YogiPlayerList[%min] = $YogiPlayerList[%i];
	             $YogiPlayerList[%i] = %temp;
              }
          }
}

// -----------------------------------------------------------------------------

// Create a new player object
function YogiAddPlayer(%name) {
         %team = PlayerList.getTeamByName(%name);
         %guid = PlayerList.getGUIDByName(%name);
         %clientid = PlayerList.getIdByName(%name);
         echo("--------------> Client ID: " @ %clientid);
         $YogiPlayerList[$YogiPlayerNum] =  new ScriptObject() {
             class = "YogiPlayer";
             name = %name;
             team = %team;
             clientId = %clientid;
             points=0;
             kills=0;
             grabs=0;
             pickups=0;
             drops=0;
             caps=0;
             returns=0;
             deaths=0;
             carrierkills=0;
             carriertks=0;
             suicides=0;
             tks=0;
             guid=%guid;
             assists=0;
             standoffreturns=0;
             assist=false;
             HoldingFlag = 0;
	         turretkills=0;
	         vehkills=0;
             score=0;
             cgkills=0;
             cgdeaths=0;
             plaskills=0;
             plasdeaths=0;
             disckills=0;
             discdeaths=0;
             lancekills=0;
             lancedeaths=0;
             rocketkills=0;
             rocketdeaths=0;
             laserkills=0;
             laserdeaths=0;
             mortarkills=0;
             mortardeaths=0;
             grenadekills=0;
             grenadedeaths=0;
             vehiclekills=0;
             vehicledeaths=0;
             turretkills=0;
             turretdeaths=0;
             crashes=0;
         };
         %newGuy = $YogiPlayerList[$YogiPlayerNum];

         echo("I just created a new player with name " @ %name);
         echo("This person has index " @ %guid);

         $YogiStatsmap =	$MissionName;

         $YogiStatsteam1 = objectiveHud.teamName[1].getValue();
         $YogiStatsteam2 = objectiveHud.teamName[2].getValue();
         $YogiPlayerNum++;
}

// -----------------------------------------------------------------------------

function YogiFindPlayerMe() {
    %i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR) {
       %name = StripMLControlChars(%p.name);
       if (strstr(%name, $YogiPref::MatchStats::Me) !=-1) {
          if (strstr(%name, $YogiPref::MatchStats::PlayerTag) != -1) {
             echo("I found: " @ %p.name);
             return %p.name;
          }
       }
             
		%i++;
		%p = PlayerList.findByIndex(%i);
	}
    return $PLAYER_ERROR;
}

// -----------------------------------------------------------------------------

// Get the index of the player in my playerlist object
function YogiGetPlayerIndex(%name) {
         %index=-1;
         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if ($YogiPlayerList[%x].name $= %name) {
                return %x;
             }
         }
         if (%index==-1) {
            YogiAddPlayer(%name);
         }
         return $YogiPlayerNum-1;
}

// -----------------------------------------------------------------------------

function YogiGetPlayerIndexById(%clientId) {
         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if ($YogiPlayerList[%x].clientId == %clientId) {
                return %x;
             }
         }
         return -1;
}


function YogiVehicleKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
         %killer = detag(%killername);
         %deadguy = detag(%victimname);

         %index = YogiGetPlayerIndex(%killer);
         $YogiPlayerList[%index].vehiclekills++;
         
         %index2 = YogiGetPlayerIndex(%deadguy);
         $YogiPlayerList[%index2].vehicledeaths++;

}


// Handles real kills (not suicides or turrets, etc)
function YogiKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
//         listPlayers();
         %killer = detag(%killername);
         %deadguy = detag(%victimname);

         %index = YogiGetPlayerIndex(%killer);
         $YogiPlayerList[%index].kills++;
         echo(%killername @ " kills++");

         %index2 = YogiGetPlayerIndex(%deadguy);
         $YogiPlayerList[%index2].deaths++;
         echo(%victimname @ " deaths++");
         echo(%msgString);
         echo("Damage Type: " @ %damageType);
         echo("DamageType::Plasma " @ $DamageType::Plasma);
         
         
         if (%damageType == $DamageType::Plasma) {
            $YogiPlayerList[%index].plaskills++;
            $YogiPlayerList[%index2].plasdeaths++;
         }
         else if (%damageType == $DamageType::Bullet) {
            $YogiPlayerList[%index].cgkills++;
            $YogiPlayerList[%index2].cgdeaths++;
         }
         else if (%damageType == $DamageType::Disc) {
            $YogiPlayerList[%index].disckills++;
            $YogiPlayerList[%index2].discdeaths++;
         }
         else if (%damageType == $DamageType::Grenade) {
            $YogiPlayerList[%index].grenadekills++;
            $YogiPlayerList[%index2].grenadedeaths++;
         }
         else if (%damageType == $DamageType::Laser) {
            $YogiPlayerList[%index].laserkills++;
            $YogiPlayerList[%index2].laserdeaths++;
         }
         else if (%damageType == $DamageType::Mortar) {
            $YogiPlayerList[%index].mortarkills++;
            $YogiPlayerList[%index2].mortardeaths++;
         }
         else if (%damageType == $DamageType::Missile) {
            $YogiPlayerList[%index].missilekills++;
            $YogiPlayerList[%index2].missiledeaths++;
         }
         else if (%damageType == $DamageType::ShockLance) {
            $YogiPlayerList[%index].lancekills++;
            $YogiPlayerList[%index2].lancedeaths++;
         }
         else if (%damageType == $DamageType::Plasma) {
            $YogiPlayerList[%index].plaskills++;
            $YogiPlayerList[%index2].plasdeaths++;
         }
         
         
         

	 if ($YogiPlayerList[%index2].HoldingFlag > 0)
	         $YogiPlayerList[%index].carrierkills++;
}

// -----------------------------------------------------------------------------

// TK!!! VOTE TO KICK!@#$%@
function YogiTeamKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
         %killer = detag(%killername);
         %index = YogiGetPlayerIndex(%killer);
         $YogiPlayerList[%index].tks++;

	 %killee = detag(%victimname);
         %index2 = YogiGetPlayerIndex(%killee);
	 if ($YogiPlayerList[%index2].HoldingFlag > 0)
	         $YogiPlayerList[%index].carriertks++;
}

// -----------------------------------------------------------------------------

// bloops you killed yourself
function YogiKillSelf(%msgType, %msgString, %victimname) {
         %idiot = detag(%victimname);
         %index = YogiGetPlayerIndex(%idiot);
         $YogiPlayerList[%index].suicides++;
}

// -----------------------------------------------------------------------------

function YogiCTurretKill(%msgType, %msgString, %victimname, %vgen, %vposs, %killername, %kgen, %kposs, %damageType) {
//         listPlayers();
         %killer = detag(%killername);
         %deadguy = detag(%victimname);

         %index = YogiGetPlayerIndex(%killer);
         %index2 = YogiGetPlayerIndex(%deadguy);

	 if (%index == %index2) // suicide
	        $YogiPlayerList[%index].suicides++;
	 else {
	        $YogiPlayerList[%index2].deaths++;
		if ($YogiPlayerList[%index].team == $YogiPlayerList[%index2].team) { // TK
			if (%damageType == 21 || %damageType == 22 || %damageType == 15) {
			}
			else {
				$YogiPlayerList[%index].tks++;
				if ($YogiPlayerList[%index2].HoldingFlag > 0)
					$YogiPlayerList[%index].carriertks++;
			}
		}
		else if (%damageType == 21 || %damageType == 22 || %damageType == 15) {
			$YogiPlayerList[%index].turretkills++;
			echo("Turret kill for " @ %killer);
		}
		else { // otherwise, normal kill from bombing or shrike blaster or tank guns or ..
			echo("Vehicle turret kill for " @ %killer @ ", damageType = " @ %damageType);
		        $YogiPlayerList[%index].kills++;
			if ($YogiPlayerList[%index2].HoldingFlag > 0)
				$YogiPlayerList[%index].carrierkills++;
		}
	}
}

// -----------------------------------------------------------------------------

// Cap, yay!!
function YogiFlagCap(%msgType, %msgString, %capper) {
         %capman = detag(%capper);
         echo("He capped: " @ %capper);
         if (%capman==0 && $YogiDemoPlayer$="") {
            %find=YogiFindPlayerMe();
            if (%find $= $PLAYER_ERROR)
               return;
            else
                $YogiDemoPlayer=%find;
                echo("The person who recorded the demo is: " @ $YogiDemoPlayer);
         }
            
         if(StrStr(%msgString, "You captured the") != -1) {
              %index = YogiGetPlayerIndex($YogiDemoPlayer);
         }
         else {
              %index = YogiGetPlayerIndex(%capman);
         }
         $YogiPlayerList[%index].caps++;
         $YogiPlayerList[%index].HoldingFlag = 0;
         echo("--------> " @ %index @ ":" @ $YogiPlayerList[%index].name @ " now has " @ $YogiPlayerList[%index].caps @ " caps.");
         
         //Assist Code By Diogenes
         $YogiPlayerList[%index].assists--;

         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if($YogiPlayerList[%index].team $= $YogiPlayerList[%x].team && $YogiPlayerList[%x].assist) {
                    $YogiPlayerList[%x].assists++;
                    $YogiPlayerList[%x].assist = false;
             }
         }
         
         // Set them both for sanity's sake
         setFlagHome(1);
         setFlagHome(2);

}

// -----------------------------------------------------------------------------

// Just a grab
function YogiFlagGrab(%msgType, %msgString, %grabber) {
         %grabguy = detag(%grabber);
         
         // Workaround for Dynamix bad coding :(
         if (%grabguy==0 && $YogiDemoPlayer$="") {
            %find=YogiFindPlayerMe();
            if (%find $= $PLAYER_ERROR)
               return;
            else
                $YogiDemoPlayer=%find;
                echo("The person who recorded the demo is: " @ $YogiDemoPlayer);
         }
         
         // Determine who took the flag
         if(StrStr(%msgString, "You took the") != -1) {
              %index = YogiGetPlayerIndex($YogiDemoPlayer);
         }
         else {
              %index = YogiGetPlayerIndex(%grabguy);
         }

         // Determine if this is a grab or a pickup
         %oteam = ($YogiPlayerList[%index].team==1) ? 2 : 1;

         if (!flagAtHome(%oteam)) {
            echo("****** THIS IS A PICKUP CAUSE " @ $YogiStatsFlag[%team]);
            $YogiPlayerList[%index].pickups++;
         }
         else {
              $YogiPlayerList[%index].grabs++;
         }
         
         setFlagAway(%oteam);
         //Assist Code By Diogenes
         $YogiPlayerList[%index].assist = true;
         $YogiPlayerList[%index].HoldingFlag = 1;
}

// -----------------------------------------------------------------------------

// You are a hero, you made a return
function YogiFlagReturn(%msgType, %msgString, %returner, %teamName, %team, %a3, %a4) {
         %returnman = detag(%returner);

          if (%returnman==0 && $YogiDemoPlayer$="") {
            %find=YogiFindPlayerMe();
            if (%find $= $PLAYER_ERROR)
               return;
            else
                $YogiDemoPlayer=%find;
                echo("The person who recorded the demo is: " @ $YogiDemoPlayer);
         }

         if(StrStr(%msgString, "You returned your flag") != -1) {
              %index = YogiGetPlayerIndex($YogiDemoPlayer);
         }
         else {
              %index = YogiGetPlayerIndex(%returnman);
         }


         $YogiPlayerList[%index].returns++;
         // Standoff Return
         if (!flagAtHome(1) && !flagAtHome(2)) $YogiPlayerList[%index].standoffreturns++;
         setFlagHome(%team);
         
         //Assist Code By Diogenes
         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if($YogiPlayerList[%index].team !$= $YogiPlayerList[%x].team && $YogiPlayerList[%x].assist) {
                   $YogiPlayerList[%x].assist = false;
             }
         }
}

// -----------------------------------------------------------------------------

function YogiFlagDrop(%msgType, %msgString, %dropper) {
         %dropguy = detag(%dropper);

         // Workaround for Dynamix bad coding :(
         if (%dropguy==0 && $YogiDemoPlayer$="") {
            %find=YogiFindPlayerMe();
            if (%find $= $PLAYER_ERROR)
               return;
            else
                $YogiDemoPlayer=%find;
                echo("The person who recorded the demo is: " @ $YogiDemoPlayer);
         }

         // Determine who dropped it
         if(StrStr(%msgString, "You dropped the") != -1) {
              %index = YogiGetPlayerIndex($YogiDemoPlayer);
         }
         else {
              %index = YogiGetPlayerIndex(%dropguy);
         }
         $YogiPlayerList[%index].drops++;
         $YogiPlayerList[%index].HoldingFlag = 0;
}

// -----------------------------------------------------------------------------

// For Misc deaths
function YogiDeath(%msgType, %msgString, %deadguy) {
         %deadman = detag(%deadguy);
         %index = YogiGetPlayerIndex(%deadman);
         $YogiPlayerList[%index].deaths++;
}

// -----------------------------------------------------------------------------

function YogiVehicleDestroy(%msgType, %msgString, %killername) {
	if (%killer $= "A turret") {
	}
	else {
		%killer = detag(%killername);
		%index = YogiGetPlayerIndex(%killer);
		$YogiPlayerList[%index].vehkills++;
		echo("Vehicle killed by " @ %killer);
	}
}

// -----------------------------------------------------------------------------

function YogiVehicleDestroyMe() {
	%index = YogiGetPlayerIndex($YogiDemoPlayer);
	$YogiPlayerList[%index].vehkills++;
	echo("Recorder killed vehicle.");
}

// -----------------------------------------------------------------------------

function YogiTeamScore(%msgType, %msgString, %team, %score) {
         $YogiTeamScores[%team] = %score;
}

// -----------------------------------------------------------------------------

// When the mission ends, lets write out and reset things
function YogiMissionEnd() {
         YogiWriteHTML();
         YogiCleanUpStats();
}

// -----------------------------------------------------------------------------

function YogiCleanUpStats() {
         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if (isObject($YogiPlayerList[%x])) {
                $YogiPlayerList[%x].delete();
             }
         }
         for (%x=1; %x <=2; %x++) {
             $YogiTeamScores[%x]=0;
             $YogiTeamPoints[%x]=0;
             $YogiStatsFlag[%x] = true;
         }

         $YogiPlayerNum=0;
         $YogiTimeLimit=-1;

}

// -----------------------------------------------------------------------------

function YogiPossibleTeamChange(%msgType, %msgString, %changer, %ignore1, %ignore2, %newteam) {
         %name = detag(%changer);

         %index=-1;
         for (%x=0; %x < $YogiPlayerNum; %x++) {
             if ($YogiPlayerList[%x].name $= %name) {
                %index = %x;
             }
         }
	
	 if (%index >= 0) {
		if ($YogiPlayerList[%index].team != %newteam)
			$YogiPlayerList[%index].team = %newteam;
	 }
}

function YogiClock(%msg, %msgString, %timeLimit, %timeLeft) {
         %time = detag(%timeLeft);
         %time = %time / (60*1000);
         echo("System clock message");
         echo("Time limit: " @ %timeLimit);
         echo("Time left: " @ %time);
         
         if (%timeLimit == %time && %timeLimit > 10) $YogiTimeLimit=%timeLimit;
         else if ($YogiTimeLimit==-1 && %timeLimit > 10) $YogiTimeLimit = %time;
         else $YogiTimePlayed = %time;
}

function YogiPlayerScore( %msgType, %msgString, %clientId, %score, %ping, %packetLoss ) {
   %id = YogiGetPlayerIndexById(%clientId);

   if ( %id != -1 ) {
    $YogiPlayerList[%id].points = %score;
    
   }
   

}

// -----------------------------------------------------------------------------

function YogiUpdateTeamPoints(%team) {
         $YogiTeamPoints[%team]=0;

         for (%x=0; %x< $YogiPlayerNum; %x++) {
             if ($YogiPlayerList[%x].team==%team) $YogiTeamPoints[%team] += $YogiPlayerList[%x].points;

         }
         echo("Scores: " @ $YogiTeamPoints[%team]);

}




// -----------------------------------------------------------------------------

function flagAtHome(%team) {
         return $YogiStatsFlag[%team];
}

// -----------------------------------------------------------------------------

function setFlagHome(%team) {
         echo("************************ FLAG " @ %team @ " IS NOW HOME ******************");
         $YogiStatsFlag[%team] = true;
}

// -----------------------------------------------------------------------------

function setFlagAway(%team) {
         $YogiStatsFlag[%team] = false;
}

function YogiLineHud(%msg, %msgString, %tag, %index, %string, %clientTeam1Name, %clientTeam1Score, %clientTeam2Name, %clientTeam2score) {
         echo(" )))))))))))))))) Line Hud Msg");
         echo("Tag: " @ %tag);
         echo("Index: " @ %index);
         echo("Client 1: " @ %clientTeam1Name);
         echo("Client 1: " @ %clientTeam1Score);

}

// -----------------------------------------------------------------------------

// Add callbacks for all the stuff that we want to track
function YogiAddCallBacks() {
    addMessageCallBack('msgExplosionKill', YogiKill);
    addMessageCallBack('msgSuicide', YogiKillSelf);
    addMessageCallBack('msgVehicleSpawnKill', YogiKill);
    addMessageCallBack('msgVehicleCrash', YogiKill);
    addMessageCallBack('msgVehicleKill', YogiVehicleKill);
    addMessageCallBack('msgTurretSelfKill', YogiKillSelf);
    addMessageCallBack('msgCTurretKill', YogiCTurretKill);
    addMessageCallBack('msgSelfKill', YogiKillSelf);
    addMessageCallBack('msgTeamKill', YogiTeamKill);
    addMessageCallBack('msgLavaKill', YogiKill);
    addMessageCallBack('msgLightningKill', YogiKill);
    addMessageCallBack('MsgRogueMineKill', YogiKill);
    addMessageCallBack('MsgHeadShot', YogiKill);
    addMessageCallBack('MsgLegitKill', YogiKill);
    
	addMessageCallback('MsgCTFFlagCapped', YogiFlagCap);
    addMessageCallback('MsgGameOver', YogiMissionEnd);
    addMessageCallBack('MsgCTFFlagTaken', YogiFlagGrab);
    addMessageCallBack('MsgCTFFlagReturned', YogiFlagReturn);
    addMessageCallBack('MsgCTFFlagDropped', YogiFlagDrop);
	addMessageCallBack('msgVehicleDestroy', YogiVehicleDestroy);
	addMessageCallBack('msgVehicleScore', YogiVehicleDestroyMe);
	addMessageCallBack('MsgClientJoinTeam', YogiPossibleTeamChange);
    addMessageCallBack('MsgTeamScoreIs', YogiTeamScore);
    
    addMessageCallback('MsgSystemClock', YogiClock);
    addMessageCallback('MsgPlayerScore', YogiPlayerScore);


//	addMessageCallBack('msgSuicide', YogiKillSelf);
//	addMessageCallBack('msgVehicleKill', YogiKill);
//	addMessageCallBack('msgCTurretKill', YogiCTurretKill);
//	addMessageCallBack('msgSelfKill', YogiKillSelf);
//	addMessageCallBack('MsgHeadshotKill', YogiKill);


//	addMessageCallBack('msgCarKill', YogiKillCarrier);
//	addMessageCallBack('msgExplosionKill', YogiDeath);
//	addMessageCallBack('msgVehicleSpawnKill', YogiDeath);
//	addMessageCallBack('msgVehicleCrash', YogiDeath);
//	addMessageCallBack('msgTurretKill', YogiDeath);
//	addMessageCallBack('msgOOBKill', YogiDeath);
//	addMessageCallBack('msgCampKill', YogiKill);
//	addMessageCallBack('msgTeamKill', YogiTeamKill);
//	addMessageCallBack('msgLavaKill', YogiDeath);
//	addMessageCallBack('msgLightningKill', YogiDeath);
//	addMessageCallBack('MsgRogueMineKill', YogiDeath);

    //addMessageCallback( 'MsgMissionEnd', YogiWriteHTML);


}

// -----------------------------------------------------------------------------

function YogiRemoveCallbacks() {
    removeMessageCallBack('MsgLegitKill', YogiKill);
	removeMessageCallback('MsgCTFFlagCapped', YogiFlagCap);
	removeMessageCallback('MsgGameOver', YogiMissionEnd);
	removeMessageCallBack('msgSuicide', YogiKillSelf);
	removeMessageCallBack('msgVehicleKill', YogiKill);
	removeMessageCallBack('msgCTurretKill', YogiKillSelf);
	removeMessageCallBack('msgSelfKill', YogiKillSelf);

	removeMessageCallBack('MsgHeadshotKill', YogiKill);

	removeMessageCallBack('MsgCTFFlagTaken', YogiFlagGrab);
	removeMessageCallBack('MsgCTFFlagReturned', YogiFlagReturn);
//	removeMessageCallBack('msgCarKill', YogiKillCarrier);

	removeMessageCallBack('msgExplosionKill', YogiDeath);
	removeMessageCallBack('msgVehicleSpawnKill', YogiDeath);
	removeMessageCallBack('msgVehicleCrash', YogiDeath);
	removeMessageCallBack('msgTurretKill', YogiDeath);
	removeMessageCallBack('msgOOBKill', YogiDeath);
//	removeMessageCallBack('msgCampKill', YogiKill);
	removeMessageCallBack('msgTeamKill', YogiTeamKill);
	removeMessageCallBack('msgLavaKill', YogiDeath);
	removeMessageCallBack('msgLightningKill', YogiDeath);
	removeMessageCallBack('MsgRogueMineKill', YogiDeath);
	removeMessageCallBack('MsgCTFFlagDropped', YogiFlagDrop);
 	removeMessageCallBack('msgVehicleDestroy', YogiVehicleDestroy);
	removeMessageCallBack('MsgClientJoinTeam', YogiPossibleTeamChange);
 

  //  removeMessageCallback( 'MsgMissionEnd', YogiWriteHTML);

}

// -----------------------------------------------------------------------------

function listAllPlayers() {
	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR) {
		echo(	"Name: ", %p.name, "(", %p.clientID, ") Team: ", %p.teamID, " Targ: ", %p.targetID,
				" Net: ", %p.ping, "|", %p.packetloss, " Flags: ", PlayerList.createFlags(%p.isSmurf, %p.isAdmin, %p.isSuperAdmin, %p.isBot),
				" Score: ", %p.score, " GUID: ", %p.guid);

		%i++;
		%p = PlayerList.findByIndex(%i);
	}
}

// -----------------------------------------------------------------------------

function YogiStatsGo() {
         canvas.popDialog(YogiStats);
         $YogiPlayDemo=true;
         StartSelectedDemo();
}

// -----------------------------------------------------------------------------
// This is from Halide's
function quit() {
		// If not saved already (can be done from another script)
        if (!$YogiPrefsSaved) {
			export("$YogiPref::*", "prefs/YogiPrefs.cs", false);
			// Set the pref that says so
			$YogiPrefsSaved = true;
        }
		parent::quit();
}

// -----------------------------------------------------------------------------

function YMSOptions::OnWake(%this) {
         YMSCssList.clear();
         %x=0;
         %select=0;
         %file = findFirstFile("matchstats/css/*.css");
         while (%file !$="") {
             %file = strreplace(%file, "/", " ");
             %file = getWord(%file, 2);
             YMSCssList.add(%file, %x);
             if (%file $= $YogiPref::MatchStats::Css) %selected=%x;
             %x++;

             %file = findNextFile("matchstats/css/*.css");
         }
         YMSCssList.setSelected(%selected);


}

// -----------------------------------------------------------------------------

function YMSCssList::onSelect(%this, %id, %text) {
         $YogiPref::MatchStats::Css = %text;
}


};

if(isFile("prefs/YogiPrefs.cs") && !$YogiPrefsLoaded) {
		exec("prefs/YogiPrefs.cs");
		$YogiPrefsLoaded = true;
}

activatePackage(YogiMatchStats);

//--- OBJECT WRITE BEGIN ---
new GuiControl(YogiStatsOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(YogiStatsWindow) {
		profile = "ShellWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "94 95";
		extent = "458 292";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "MATCH STATS OPTIONS";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 54";
			extent = "191 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Demo Recorder\'s Name:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 89";
			extent = "176 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Demo Recorder\'s Tag:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(YogiStatsName) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 45";
			extent = "159 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$YogiPref::MatchStats::Me";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(YogiStatsTag) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 81";
			extent = "159 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$YogiPref::MatchStats::PlayerTag";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "66 227";
			extent = "140 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "YogiStartTracking();";
			helpTag = "0";
			text = "GO!";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "243 228";
			extent = "140 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "YogiStatsDialogClose();";
			helpTag = "0";
			text = "Cancel";
			simpleStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 124";
			extent = "176 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Opponent\'s Tag:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "61 161";
			extent = "176 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Date:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 196";
			extent = "176 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Reason:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(YogiStatsOTag) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 116";
			extent = "159 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$YogiPref::MatchStats::OTag";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(YogiStatsDate) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 152";
			extent = "159 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$YogiPref::MatchStats::Date";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new ShellTextEditCtrl(YogiStatsReason) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "250 189";
			extent = "159 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$YogiPref::MatchStats::Reason";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
	};
};
//--- OBJECT WRITE END ---
//--- OBJECT WRITE BEGIN ---
new GuiControl(YMSOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "129 126";
		extent = "370 200";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "MATCH STATS OPTIONS";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellPopupMenu(YMSCssList) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "139 58";
			extent = "185 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";


		};
		new GuiTextCtrl() {
			profile = "GuiChatHudProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "59 67";
			extent = "53 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "CSS File:";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};
//--- OBJECT WRITE END ---
